<?php
header("Cache-Control: no-cache, must-revalidate, Content-Type: text/plain"); // HTTP/1.1
echo '<tt>';
// исправить на свои для S1:
$host = '192.168.1.208';
$mac = array(0xED, 0x2F, 0xC7, 0x0D, 0x43, 0xB4);	//mac = b4:43:d:c7:2f:ed, массив в обратном порядке

// не трогать:
$port = 80;
$timeout = 10;
$key = array(0x09, 0x76, 0x28, 0x34, 0x3f, 0xe9, 0x9e, 0x23, 0x76, 0x5c, 0x15, 0x13, 0xac, 0xcf, 0x8b, 0x02);
$iv = array(0x56, 0x2e, 0x17, 0x99, 0x6d, 0x09, 0x3d, 0x28, 0xdd, 0xb3, 0xba, 0x69, 0x5a, 0x2e, 0x6f, 0x58);
$id = array(0, 0, 0, 0);

//Discover();						//поиск устройств в сети
Auth();								//авторизация
//$payload = RM_Check_temperature();//проверка датчика температуры RM
//$payload = S1_armset(0);			//0-снятие с охраны, 1-part, 2-full
$payload = Check_Status();			//проверить статус

echo '<hr>payload decrypted:<br>';
print_dec_table($payload);
print_hex_table($payload);

function print_hex_table($payload){
	echo '<br>';
	for ($y=0; $y<(count($payload)/16) ; $y++) {
		for ($i=0; $i<16; $i++) {
			if (($i+$y*16)<count($payload)){
				if (($i==0) && ($y<16)) echo '00'.dechex($y).'0&nbsp&nbsp&nbsp';
				if (($i==0) && ($y>=16)) echo '0'.dechex($y).'0&nbsp&nbsp&nbsp';
				if ($i==8) echo '&nbsp';
				if (($payload[$i+$y*16]<16) && ($payload[$i+$y*16]!=0)) echo '<font color="silver">0</font>';
				if ($payload[$i+$y*16]==0) echo '<font color="silver">00 </font>';
				else echo dechex($payload[$i+$y*16]).' ';
			}
		}
		echo '<br>';
	}
}

function print_dec_table($payload){
	echo '<br>';
	for ($y=0; $y<(count($payload)/16) ; $y++) {
		for ($i=0; $i<16; $i++) {
			if (($i+$y*16)<count($payload)){
				if (($i==0) && ($y<16)) echo '00'.dechex($y).'0&nbsp&nbsp&nbsp';
				if (($i==0) && ($y>=16)) echo '0'.dechex($y).'0&nbsp&nbsp&nbsp';
				if ($i==8) echo '&nbsp';
				if ($payload[$i+$y*16]<10) echo '<font color="silver">00</font>';
				else if ($payload[$i+$y*16]<100) echo '<font color="silver">0</font>';
				echo $payload[$i+$y*16].' ';
			}
		}
		echo '<br>';
	}
}

function bytearray($size){
   	$packet = array();
    for($i = 0 ; $i < $size ; $i++){
    	$packet[$i] = 0;
    }
    return $packet;
}

function byte2array($data){
	return array_merge(unpack('C*', $data));
}

function byte($array){
	return implode(array_map("chr", $array));
}

function aes128_cbc_encrypt($key, $data, $iv) {
  return mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key, $data, MCRYPT_MODE_CBC, $iv);
}

function aes128_cbc_decrypt($key, $data, $iv) {
  return mcrypt_decrypt(MCRYPT_RIJNDAEL_128, $key, $data, MCRYPT_MODE_CBC, $iv);
}

function key2str(){
	global $key;
	return implode(array_map("chr", $key));
}

function iv2str(){
	global $iv;
	return implode(array_map("chr", $iv));
}

function Discover(){
    	$devices = array();
		$s = socket_create(AF_INET, SOCK_DGRAM, SOL_UDP);
  		socket_connect($s ,'8.8.8.8', 53);  // connecting to a UDP address doesn't send packets
  		socket_getsockname($s, $local_ip_address, $port);	//$local_ip_address - внешний IP
  		socket_close($s);
		$local_ip_address = '192.168.1.1';
		$cs = socket_create(AF_INET, SOCK_DGRAM, SOL_UDP);
   		if($cs){
   			//socket_set_option($cs, SOL_SOCKET, SO_REUSEADDR, true);
    		socket_set_option($cs, SOL_SOCKET, SO_BROADCAST, true);
    		socket_set_option($cs, SOL_SOCKET, SO_RCVTIMEO, array('sec'=>1, 'usec'=>0));	// таймаут: 1 секунда, 0 микросекунд
    		socket_bind($cs, 0, 0);
   		}
  		$address = explode('.', $local_ip_address);
		$packet = bytearray(0x30);
	    $timezone = (int)intval(date("Z"))/-3600;
	  	$year = date("Y");
		if($timezone < 0){
		    $packet[0x08] = 0xff + $timezone - 1;
		    $packet[0x09] = 0xff;
		    $packet[0x0a] = 0xff;
		    $packet[0x0b] = 0xff;
		}
		else{
			$packet[0x08] = $timezone;
		    $packet[0x09] = 0;
		    $packet[0x0a] = 0;
		    $packet[0x0b] = 0;
		}    
		$packet[0x0c] = $year & 0xff;
		$packet[0x0d] = $year >> 8;
		$packet[0x0e] = intval(date("i"));
		$packet[0x0f] = intval(date("H"));
		$subyear = substr($year, 2);
		$packet[0x10] = intval($subyear);
		$packet[0x11] = intval(date('N'));
		$packet[0x12] = intval(date("d"));
		$packet[0x13] = intval(date("m"));
		$packet[0x18] = intval($address[0]);
		$packet[0x19] = intval($address[1]);
		$packet[0x1a] = intval($address[2]);
		$packet[0x1b] = intval($address[3]);
		$packet[0x1c] = $port & 0xff;
		$packet[0x1d] = $port >> 8;
		$packet[0x26] = 6;
		$checksum = 0xbeaf;
		for($i = 0 ; $i < sizeof($packet) ; $i++){
	      $checksum += $packet[$i];
	    }
	   	$checksum = $checksum & 0xffff;
		$packet[0x20] = $checksum & 0xff;
		$packet[0x21] = $checksum >> 8;
		socket_sendto($cs, byte($packet), sizeof($packet), 0, '192.168.1.255', 80);
		while(socket_recvfrom($cs, $response, 1024, 0, $from, $port)){
			$host = '';
			$responsepacket = byte2array($response);
			echo '<hr>';
			print_r($responsepacket);
			echo '<br>';

			$devtype = sprintf("0x%x%x", $responsepacket[0x35], $responsepacket[0x34]);
			$host_array = array_slice($responsepacket, 0x36, 4);
			$mac = array_slice($responsepacket, 0x3a, 6);

			foreach ( array_reverse($host_array) as $ip ) {
 				$host .= $ip . ".";
			}
			$host = substr($host, 0, strlen($host) - 1);
			if($device != NULL){
                $device->name = str_replace("\0", '', byte(array_slice($responsepacket, 0x40)));
				echo 'device: '.$device->name.':<br>';
				array_push($devices, $device);
			}
			echo 'mac: '.dechex($mac[5]).':'.dechex($mac[4]).':'.dechex($mac[3]).':'.dechex($mac[2]).':'.dechex($mac[1]).':'.dechex($mac[0]).'<br>';
			echo 'host: '.$host.'<br>';
			echo 'port: '.$port.'<br>';
			echo 'devtype: '.$devtype.'<br>';
		}

		if($cs){
			socket_close($cs);
		}

		return $devices;

    }

function Auth(){
	global $key, $id, $id_authorized, $key_authorized;
	echo '<hr>';
	if (isset($key_authorized)) {
		$id = $id_authorized;
		$key = $key_authorized;
		echo "Установили вручную:<br>";
	} else {
		$payload = bytearray(0x50);
		$payload[0x04] = 0x31;
		$payload[0x05] = 0x31;
		$payload[0x06] = 0x31;
		$payload[0x07] = 0x31;
		$payload[0x08] = 0x31;
		$payload[0x09] = 0x31;
		$payload[0x0a] = 0x31;
		$payload[0x0b] = 0x31;
		$payload[0x0c] = 0x31;
		$payload[0x0d] = 0x31;
		$payload[0x0e] = 0x31;
		$payload[0x0f] = 0x31;
		$payload[0x10] = 0x31;
		$payload[0x11] = 0x31;
		$payload[0x12] = 0x31;
		$payload[0x1e] = 0x01;
		$payload[0x2d] = 0x01;
		$payload[0x30] = ord('G');
		$payload[0x31] = ord('T');
		$payload[0x32] = ord('-');
		$payload[0x33] = ord('I');
		$payload[0x34] = ord('9');
		$payload[0x35] = ord('1');
		$payload[0x36] = ord('0');
		$payload[0x37] = ord('0');
		$response = send_packet(0x65, $payload);
		//print_r($response);
		//echo '<hr>';
		$enc_payload = array_slice($response, 0x38);
		//print_r($enc_payload);
		
		$payload = byte2array(aes128_cbc_decrypt(key2str(), byte($enc_payload), iv2str()));
		$id = array_slice($payload, 0x00, 4);
		$key = array_slice($payload, 0x04, 16);
	}
	echo 'NEW KEY:';
	print_dec_table($key);
	echo 'NEW ID:';
	print_dec_table($id);
}

function send_packet($command, $payload){
	global $host, $port, $id, $mac;
	
	$cs = socket_create(AF_INET, SOCK_DGRAM, SOL_UDP);
	if($cs){
		socket_set_option($cs, SOL_SOCKET, SO_REUSEADDR, 1);
		socket_set_option($cs, SOL_SOCKET, SO_BROADCAST, 1);
		socket_bind($cs, 0, 0);
	}
	$count = ($count + 1) & 0xffff;
	$packet = bytearray(0x38);
	$packet[0x00] = 0x5a;
	$packet[0x01] = 0xa5;
	$packet[0x02] = 0xaa;
	$packet[0x03] = 0x55;
	$packet[0x04] = 0x5a;
	$packet[0x05] = 0xa5;
	$packet[0x06] = 0xaa;
	$packet[0x07] = 0x55;
	$packet[0x24] = 0x2a;
	$packet[0x25] = 0x27;
	$packet[0x26] = $command;
	$packet[0x28] = $count & 0xff;
	$packet[0x29] = $count >> 8;
	$packet[0x2a] = $mac[0];
	$packet[0x2b] = $mac[1];
	$packet[0x2c] = $mac[2];
	$packet[0x2d] = $mac[3];
	$packet[0x2e] = $mac[4];
	$packet[0x2f] = $mac[5];
	$packet[0x30] = $id[0];
	$packet[0x31] = $id[1];
	$packet[0x32] = $id[2];
	$packet[0x33] = $id[3];
	$checksum = 0xbeaf;
	for($i = 0 ; $i < sizeof($payload) ; $i++){
	  $checksum += $payload[$i];
	  $checksum = $checksum & 0xffff;  
	}	    
	$aes = byte2array(aes128_cbc_encrypt(key2str(), byte($payload), iv2str()));
	$packet[0x34] = $checksum & 0xff;
	$packet[0x35] = $checksum >> 8;
	for($i = 0 ; $i < sizeof($aes) ; $i++){
	  array_push($packet, $aes[$i]);
	}
	$checksum = 0xbeaf;
	for($i = 0 ; $i < sizeof($packet) ; $i++){
	  $checksum += $packet[$i];
	  $checksum = $checksum & 0xffff;
	}	    
	$packet[0x20] = $checksum & 0xff;
	$packet[0x21] = $checksum >> 8;
	$starttime = time();
	$from = '';
	socket_sendto($cs, byte($packet), sizeof($packet), 0, $host, $port);
	socket_set_option($cs, SOL_SOCKET, SO_RCVTIMEO, array('sec'=>$timeout, 'usec'=>0));
	$ret = socket_recvfrom($cs, $response, 1024, 0, $from, $port);
	if($cs){
		socket_close($cs);
	}
	return byte2array($response);
}

function RM_Check_temperature(){
	$temp = 0;
	$packet = bytearray(16);
	$packet[0] = 0x01;	
	$response = send_packet(0x6a, $packet);
	$err = hexdec(sprintf("%x%x", $response[0x23], $response[0x22]));
	if($err == 0){
		$enc_payload = array_slice($response, 0x38);
		if(count($enc_payload) > 0){
			$payload = byte2array(aes128_cbc_decrypt(key2str(), byte($enc_payload), iv2str()));
			$temp = ($payload[0x04] * 10 + $payload[0x05]) / 10;
		}
	}
	return $payload;
}

function S1_armset($mode){
	//FULL:
	//0000   11 00 00 00 02 00 00 00  00 00 00 00 00 00 00 00 
	//0010   2c 05 b2 42 00 01 00 00  00 70 91 5b 00 00 00 00 
	//0020   2c 05 b2 42 00 00 00 00  00 00 00 00 00 00 00 00
	//PART:
	//0000   11 00 00 00 01 00 00 00  00 00 00 00 00 00 00 00 
	//0010   00 00 00 00 00 00 00 00  74 92 6f 5a 01 00 00 00 
	//0020   ab 00 14 43 00 00 00 00  00 00 00 00 00 00 00 00
	//DISARM:
	//0000   11 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00 
	//0010   00 00 00 00 00 00 00 00  74 92 6f 5a 01 00 00 00 
	//0020   ab 00 14 43 00 00 00 00  00 00 00 00 00 00 00 00 
	$temp = 0;
	$packet = bytearray(5);	//вообщето нужно 48 и еще ниже закоментированное
	$packet[0x00] = 0x11;
	$packet[0x04] = $mode;	//2 - full, 1 - part, 0 - disarm
	/*
	$packet[0x10] = 0x2c;
	$packet[0x11] = 0x05;
	$packet[0x12] = 0xb2;
	$packet[0x13] = 0x42;
	
	$packet[0x15] = 0x01;
	
	$packet[0x19] = 0x70;
	$packet[0x1a] = 0x91;
	$packet[0x1b] = 0x5b;
	
	$packet[0x20] = 0x2c;
	$packet[0x21] = 0x05;
	$packet[0x22] = 0xb2;
	$packet[0x23] = 0x42;
	*/
	$response = send_packet(0x6a, $packet);
	$err = hexdec(sprintf("%x%x", $response[0x23], $response[0x22]));
	if($err == 0){
		$enc_payload = array_slice($response, 0x38);
		if(count($enc_payload) > 0){
			$payload = byte2array(aes128_cbc_decrypt(key2str(), byte($enc_payload), iv2str()));
		}
	}
	return $payload;
}

function Check_Status(){
	
	$data = array();
	
	$packet = bytearray(16);
	$packet[0] = 0x12;
	
	$response = send_packet(0x6a, $packet);
	$err = hexdec(sprintf("%x%x", $response[0x23], $response[0x22]));
	
	if($err == 0){
		$enc_payload = array_slice($response, 0x38);
		if(count($enc_payload) > 0){
			$payload = byte2array(aes128_cbc_decrypt(key2str(), byte($enc_payload), iv2str()));
			$data['status_id'] = $payload[0x04];
			switch ($data['status_id']) {
				case 0x00:
					$data['status'] = 'disarm';
					break;
				case 0x01:
					$data['status'] = 'part';
					break;
				case 0x02:
					$data['status'] = 'full';
					break;
				default:
					$data['status'] = 'Unknown: '.$data['status_id'];
			}
		}
	}
	echo '<hr>'.$data['status'].'<br>';
	return $payload;
}

?>
